/*****************************************************************************
 * BitStream.h: Bitstream Read/Write Class
 *****************************************************************************
 * Copyright (C) 2004-2005 ShrinkTo5
 *
 * Authors: Ocrana		 <info@shrinkto5.com>
 *          Andrej Grecu <info@shrinkto5.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#pragma once

#ifndef _LESSDEBUG
#define _ASSERTX(x) if(!(x)) { AfxThrowUserException(); } 
#else
#define _ASSERTX(x) _ASSERT(x)
#endif

// BIT STREAM
// **********
//  + Object must be attached to a buffer
//  + Can read up to 63 bits into a value
class BitStream
{
public:
	BitStream(void);
	~BitStream(void);

	// tools
	virtual int TestNextBits(__int64 value, int count);
	virtual int SeekNextByte();
	virtual int MPEG2_GetNextStartCode();

	// read bits
	__int64 ReadBits(int count);
	int ReadBit();

	// write bits
	int WriteBits(__int64 value, int count);
	int WriteBit(int value);

	// seeking through stream
	virtual int Seek(int count);

	// attach to buffer
	virtual void AttachBuffer(void *buffer, int length);

protected:
	
	int bitPos;
	int BUFFER_SIZE;
	unsigned char *pBuffer;
	unsigned char *pOrgBuffer;

	static unsigned char Mask[8];
};
