/*****************************************************************************
 * BitStreamReader.h: Read from Bitstreams
 *****************************************************************************
 * Copyright (C) 2004-2005 ShrinkTo5
 *
 * Authors: Ocrana		 <info@shrinkto5.com>
 *          Andrej Grecu <info@shrinkto5.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#if !defined(AFX_BITSTREAMREADER_H__B3150F49_FB9E_4BB7_AC04_574176498CC1__INCLUDED_)
#define AFX_BITSTREAMREADER_H__B3150F49_FB9E_4BB7_AC04_574176498CC1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
#include "EOFBSException.h"

/*
	see .cpp for comments...
*/
class BitStreamReader
{
public:
	bool isByteAligned();
	bool TestNextBits(char *bits);
	unsigned long BytePosition();
	unsigned long BitPosition();

	static int GetValue(char *bits,int &l);
	static int GetValue(char *bits);


	unsigned int ReadBits(int count);
	int ReadBit();

	bool Open(char *filename);
	void Close();

	BitStreamReader();
	virtual ~BitStreamReader();

private:
	unsigned long m_bitcounter;
	unsigned long m_bytecounter;
	FILE *m_id;
	void ResetBitStream();
	void LoadBuffer();
	int m_bitpos;
	long m_bytepos;
	int m_bitbuffer_size;
	unsigned char *m_bitbuffer;
};

#endif // !defined(AFX_BITSTREAMREADER_H__B3150F49_FB9E_4BB7_AC04_574176498CC1__INCLUDED_)