/*****************************************************************************
 * Picture.h: Rebuild Picture Class
 *****************************************************************************
 * Copyright (C) 2004-2005 ShrinkTo5
 *
 * Authors: Ocrana		 <info@shrinkto5.com>
 *          Andrej Grecu <info@shrinkto5.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#pragma once

#include "BitStream.h"
#include "Slice.h"
#include "CompressionStrategy.h"

// -- attention also defined in bitratecontrol.h
//#define MAX_SLICE_SKIP_PROB  1000

class Picture
{
public:
	Picture(void);
	~Picture(void);

	virtual int AttachBuffer(unsigned char *buffer, int length, unsigned char *wbuffer, int posLUTindex);

	virtual unsigned char *GetDCPicture();


	int pictureType;
	int intraDCPrecision;
	int picture_structure;
	int frame_pred_frame_dct;
	int concealmentMotionVectors;
	int qScaleType;
	int intraVLCFormat;
	int alternateScan;
	int chroma_format;
	int f_code[2][2];
	int absNumPicture;
	int absNumMacroBlock;
	int width;
	int height;
	int aspect_ratio;
	int dest_width;
	int dest_height;
	int max_width;
	int max_height;
	int demoMode;
	int sliceSkipProb;
	int previewPicture;

	BitrateControl *BitRateControl;
    
	int numSlices;
	Slice Slices;

	STARTCODE_POS *stPosLUT;

protected:
	unsigned char *pBuffer;
	int bufferSize;

	int posLUTindex;
	int relPos;

	BitStream bstream;

	virtual int FindNextSliceStartCode(int *index);
	virtual int CountSlices();
	virtual int SetSliceData(Slice *pSlice);
	virtual void GenerateDCPicture();
	virtual void ReallocPreviewBitmaps();

	int internal_width;
	int internal_height;
	int internal_dest_width;
	int internal_dest_height;
	unsigned char *DCYUVBitmap[3];
	unsigned char *DCYUVBitmapAR[3];
	unsigned char *DCRGBBitmap;

	static int intraDCshift[4];

};
