/*****************************************************************************
 * VLC.h: Read and Write VLC Tables
 *****************************************************************************
 * Copyright (C) 2004-2005 ShrinkTo5
 *
 * Authors: Ocrana		 <info@shrinkto5.com>
 *          Andrej Grecu <info@shrinkto5.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#pragma once
#include "BitStream.h"

typedef struct tagVLC_ENTRY
{
	char zeroes;	
	char digits;
	int number;
} VLC_ENTRY;

typedef struct tagVLC_SIMPLEENTRY
{
	char digits;
	int number;
} VLC_SIMPLEENTRY;

class VLC : public BitStream
{
public:
	VLC(void);
	~VLC(void);

	VLC_ENTRY     *table;
	unsigned char *indices;

	virtual int ReadVLC();
	virtual int ReadSimpleVLC(VLC_SIMPLEENTRY *table);

	virtual int WriteVLC(int tablePos);
	virtual int WriteSimpleVLC(VLC_SIMPLEENTRY *table, int tablePos);
};
