// BurnPlugin.cpp : Implementierungsdatei
//
// 18.09.2005 Added extended Logging for better Support Requets
//
#include "stdafx.h"
#include "ShrinkTo5Gui.h"
#include "BurnPlugin.h"
#include "UnicodeHelpers.h"
#include ".\burnplugin.h"

extern const UINT WM_BURN_DONE;
//// Hilfsfunktionen
__inline CString GetGUIText(__int32 nTextID)
{
	TCHAR chText[2048] = _T("");
	__int32 nLength = 2048;

	FoxBurner::GetText(nTextID, chText, &nLength);

	return CString(chText);
}
// CBurnPlugin-Dialogfeld
//// Callbacks

void OnFinalizing(CBurnPlugin* pThis)
{
	pThis->OnLogEvent(_T("Finalize disc"),1);  //Succefull reseted
}
void OnWriteDone(const TCHAR *pcError, CBurnPlugin *pThis)
{

	CString strError(pcError);

	if(strError.IsEmpty())
	{
		pThis->OnLogEvent(_T("Burn Done."),1);  //Succefull reseted
		pThis->PostMessage(WM_BURN_DONE, 0, 0);
	}
	else
	{
		pThis->OnLogEvent(_T("Burn done with error :" + strError),0);  //Succefull reseted
		pThis->PostMessage(WM_BURN_DONE, 1, 1);
	}




}
void OnProcessEvent(float fPercent, float fDeviceBuffer, float fCache, double dBytesWritten, double dImageSize, CBurnPlugin *pThis)
{
	pThis->m_burnprogress.SetPos((int)fPercent);
}

IMPLEMENT_DYNAMIC(CBurnPlugin, CDialog)
CBurnPlugin::CBurnPlugin(CWnd* pParent /*=NULL*/)
	: CBDialog(CBurnPlugin::IDD, pParent)
{
	onWork=false;
	nTimercounter=0;
}

CBurnPlugin::~CBurnPlugin()
{
}

void CBurnPlugin::DoDataExchange(CDataExchange* pDX)
{
	CBDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_OPTBUT, mOptBut);
	DDX_Control(pDX, IDC_OPT1, xOpt1);
	DDX_Control(pDX, IDC_OPT2, xOpt2);
	DDX_Control(pDX, IDC_OPT3, xOpt3);
	DDX_Control(pDX, IDC_OPENSOURCE, bSource);
	DDX_Control(pDX, IDC_BURNFOLDER, cBurnFolder);
	DDX_Control(pDX, IDC_SPEED, m_ctrlSpeed);
	DDX_Control(pDX, IDC_VOLUMELABEL, m_strVolumeLabel);
	DDX_Control(pDX, IDC_LIST1, m_cListLog);
	DDX_Control(pDX, IDC_STOPBUT, m_bStop);
	DDX_Control(pDX, IDC_STARTBUT, m_bStart);
	DDX_Control(pDX, IDC_DEVICE, cbDevice);
	DDX_Control(pDX, IDC_PROGRESS1, m_burnprogress);
	DDX_Control(pDX, IDC_BERASE, bErase);
	DDX_Control(pDX, IDC_LOGSAVE, bSaveLog);
	DDX_Control(pDX, IDC_INF, xHeader);

}

const UINT WM_BURN_DONE = ::RegisterWindowMessage(_T("WM_BURN_DONE"));
BEGIN_MESSAGE_MAP(CBurnPlugin, CBDialog)
	ON_WM_CTLCOLOR()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_OPTBUT, OnBnClickedOptbut)
	ON_BN_CLICKED(IDC_OPENSOURCE, OnBnClickedOpensource)
	ON_CBN_SELCHANGE(IDC_DEVICE, OnCbnSelchangeDevice)
	ON_CBN_SELCHANGE(IDC_SPEED, OnCbnSelchangeSpeed)
	ON_CBN_DROPDOWN(IDC_SPEED, OnCbnDropdownSpeed)
	ON_BN_CLICKED(IDC_STARTBUT, OnBnClickedStartbut)
	ON_BN_CLICKED(IDC_LOGSAVE, OnBnClickedLogsave)
	ON_BN_CLICKED(IDC_BERASE, OnBnClickedBerase)
	ON_REGISTERED_MESSAGE(WM_BURN_DONE, OnBurnDone)
	ON_BN_CLICKED(IDC_STOPBUT, OnBnClickedStopbut)
END_MESSAGE_MAP()


// CBurnPlugin-Meldungshandler

BOOL CBurnPlugin::OnInitDialog()
{
	CBDialog::OnInitDialog();

	__int32 nError;

	SetBitmapStyle(StyleCenter);
	SetBitmap(IDB_BACKBURN);

	FillMultiLangGui();

	CBitmap bmp;
	// normal tree images
	m_LogIcons.Create(16, 16, TRUE | ILC_COLOR32, 8, 0);
	ASSERT(m_LogIcons.m_hImageList);
	bmp.LoadBitmap(IDB_EVENTS);
	m_LogIcons.Add( &bmp, RGB(255,255,255));
	bmp.DeleteObject();
	m_cListLog.SetImageList(&m_LogIcons, LVSIL_SMALL);

	m_cListLog.InsertColumn(0, _T(""), LVCFMT_LEFT, 25);
	m_cListLog.InsertColumn(1, GetText(GUI_9), LVCFMT_LEFT, 70);
	m_cListLog.InsertColumn(2, GetText(GUI_10), LVCFMT_LEFT, 300);

	m_cListLog.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	//Paint all Header in dark grey/bold
    LOGFONT new_logfont;
	GetDlgItem(IDC_HEADERA1)->GetFont()->GetLogFont(&new_logfont);
	new_logfont.lfWeight = FW_BOLD;
	new_font.CreateFontIndirect(&new_logfont);
	GetDlgItem(IDC_HEADERA1)->SetFont(&new_font);
	GetDlgItem(IDC_HEADERA2)->SetFont(&new_font);
	GetDlgItem(IDC_HEADERA3)->SetFont(&new_font);
	GetDlgItem(IDC_HEADERA4)->SetFont(&new_font);
	GetDlgItem(IDC_HEADERA5)->SetFont(&new_font);
	GetDlgItem(IDC_HEADERA6)->SetFont(&new_font);
	GetDlgItem(IDC_HEADERA7)->SetFont(&new_font);

	if(m_ToolTip.Create(this))
	{
		m_ToolTip.SetDelayTime(TTDT_INITIAL,10);
		m_ToolTip.AddTool(&bErase,GetText(BURN_2));
		m_ToolTip.AddTool(&bSource,GetText(TOOL_8));
		m_ToolTip.AddTool(&bSaveLog,GetText(TOOL_7));
		m_ToolTip.AddTool(&m_bStart,GetText(BURN_1));
		m_ToolTip.AddTool(&xHeader,GetText(MIX_1));
		m_ToolTip.Activate(TRUE);
	}

	bErase.SetSkin(IDB_RW, 1, 1, 1, 0, 0, 0, 0);
	m_bStart.SetSkin(IDB_START, 1, 1, 1, 0, 0, 0, 0);
	m_bStop.SetSkin(IDB_STOP, 1, 1, 1, 0, 0, 0, 0);
	bSource.SetSkin(IDB_BUTTON, 1, 1, 1, 0, 0, 0, 0);
	mOptBut.SetSkin(IDB_DOWN, 0, 0, 0, 0, 0, 0, 0);
	mOptBut.SetCheck(0);

	xOpt1.SetCheck(1);
	xOpt2.SetCheck(1);
	xOpt3.SetCheck(1);
	m_burnprogress.SetRange(0,100);

	FoxBurner::Initialize("",TRUE);
	OnLogEvent(_T("CD/DVD Writer successfull initialized"),1);

	//// FoxBurner SDK
	FoxBurner::SetBurnDoneEventCallback((BurnDoneEvent)OnWriteDone, this);
    FoxBurner::SetFinalizeEventCallback((FinalizeEvent)OnFinalizing, this);
    FoxBurner::SetProcessEventCallback((ProcessEvent)OnProcessEvent, this);

	FoxBurner::SetLanguage(LangID,EncLangFile);

	//Plugin is here. No start to burn.
	nError = FoxBurner::CreateProject(BS_BURNER_ISOVIDEODVD);

	FillDrives();
	SetSpeedCombo();

	//// bentigte Daten holen
	SOptions OTmp;
	FoxBurner::GetOptions(&OTmp);

	if (strcmp(OTmp.chVolumeLabel, "BS_NDEF"))
	{
		m_strVolumeLabel.SetWindowText((CString)OTmp.chVolumeLabel);
	}

	xOpt1.SetCheck(OTmp.bEjectAfterBurn);
	xOpt2.SetCheck(OTmp.bUnderrunProtection);

	this->GetDlgItem(IDC_STOPBUT)->EnableWindow(FALSE);




	return TRUE;  // return TRUE unless you set the focus to a control
	// AUSNAHME: OCX-Eigenschaftenseite muss FALSE zurckgeben.
}

HBRUSH CBurnPlugin::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CBDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if (pWnd->GetDlgCtrlID() == IDC_HEADERA1 || pWnd->GetDlgCtrlID() == IDC_HEADERA2 || pWnd->GetDlgCtrlID() == IDC_HEADERA3|| pWnd->GetDlgCtrlID() == IDC_HEADERA4|| pWnd->GetDlgCtrlID() == IDC_HEADERA5|| pWnd->GetDlgCtrlID() == IDC_HEADERA6 || pWnd->GetDlgCtrlID() == IDC_HEADERA7 || pWnd->GetDlgCtrlID() == IDC_INF)
	{
	pDC->SetTextColor(RGB(102,102,102)); //Textfarbe
	pDC->SetBkMode(TRANSPARENT);
	return (HBRUSH)GetStockObject(NULL_BRUSH);
	}

	if (pWnd->GetDlgCtrlID() == IDC_OPT1 || pWnd->GetDlgCtrlID() == IDC_OPT2 || pWnd->GetDlgCtrlID() == IDC_OPT3){
		RECT rc;


		pDC->SetBkMode(TRANSPARENT);

		HBRUSH hBrush = (HBRUSH)GetProp(pWnd->m_hWnd, PROP_HBRUSH);
		if(hBrush )
		{
			return hBrush;
		}

		return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
	}
	return hbr;
}

void CBurnPlugin::OnBnClickedOptbut()
{
	if(mOptBut.GetCheck()==1){
		this->GetDlgItem(IDC_OPT1)->ShowWindow(TRUE);
		this->GetDlgItem(IDC_OPT2)->ShowWindow(TRUE);
		this->GetDlgItem(IDC_OPT3)->ShowWindow(TRUE);
	}else{
		this->GetDlgItem(IDC_OPT1)->ShowWindow(FALSE);
		this->GetDlgItem(IDC_OPT2)->ShowWindow(FALSE);
		this->GetDlgItem(IDC_OPT3)->ShowWindow(FALSE);
	}
}

void CBurnPlugin::OnBnClickedOpensource()
{
	//--------------------------------------------------
	//API Folder Selectdialog
	//--------------------------------------------------
	BROWSEINFO		info;
	LPITEMIDLIST	selectedFolder;
	CString wTitle = GetText(GUI_2);

	TCHAR displayName[MAX_PATH];
	TCHAR selectedPath[MAX_PATH];

	info.hwndOwner = this->m_hWnd;
	info.pidlRoot = NULL;
	info.pszDisplayName = displayName;
	info.lpszTitle = wTitle.GetBuffer(); //GUI_2
	wTitle.ReleaseBuffer();
	info.ulFlags = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
	info.lpfn = NULL;
	info.lParam = NULL;
	info.iImage = 0;

	selectedFolder = SHBrowseForFolder(&info);

	if (selectedFolder != NULL) {
		if (SHGetPathFromIDList(selectedFolder, selectedPath)) {

			cBurnFolder.SetWindowText(selectedPath);
		}
	}
}

void CBurnPlugin::FillDrives()
{
	//// Laufwerke
	TCHAR strDevices[26][50];
	int nDevices = 0;
	CString strDevice;
	TCHAR cDevice[2];
	cDevice[0] = '\0';

	// alle Laufwerke holen
	FoxBurner::GetDevices(strDevices, (__int32*)&nDevices, BS_TRUE);
	for (int i = 0; i < nDevices; i++)
	{
		((CComboBox*)GetDlgItem(IDC_DEVICE))->AddString(strDevices[i]);
	}

	// aktuelles Laufwerk selektieren
	FoxBurner::GetDevice(cDevice);
	strDevice = CString(cDevice);
	strDevice += _T(":");
	((CComboBox*)GetDlgItem(IDC_DEVICE))->SelectString(-1, strDevice);

	// Auswahl berprfen
	if (0 > ((CComboBox*)GetDlgItem(IDC_DEVICE))->GetCurSel())
	{
		((CComboBox*)GetDlgItem(IDC_DEVICE))->SetCurSel(0);
		OnCbnSelchangeDevice();
	}
	//// Ende (Laufwerke)
}

void CBurnPlugin::OnCbnSelchangeDevice()
{
	CString strDevice;
	TCHAR chDevice[2];

	GetDlgItemText(IDC_DEVICE, strDevice);
	FoxBurner::GetDevice(chDevice);

	if (! strDevice.IsEmpty() && strDevice.GetAt(0) != chDevice[0])
	{
		int nError = FoxBurner::SetDevice(strDevice.GetAt(0));
		if (BS_SDK_ERROR_NO != nError)
		{
            //SetStatusText(GetGUIText(nError));
		}
		else
		{
			FoxBurner::SetBurnSpeed(BS_MAX_SPEED);
			//m_SettingsBurning.SetSpeedCombo();
		}
	}
}

void CBurnPlugin::OnCbnSelchangeSpeed()
{
	FoxBurner::SetBurnSpeed(m_ctrlSpeed.GetItemData(m_ctrlSpeed.GetCurSel()));
}

void CBurnPlugin::SetSpeedCombo(void)
{
	CString strSpeed;
	m_ctrlSpeed.ResetContent();
	strSpeed = GetGUIText(BS_SDK_MESSAGE_12);
	m_ctrlSpeed.SetItemData(m_ctrlSpeed.AddString(strSpeed),BS_MAX_SPEED);
	m_ctrlSpeed.SetCurSel(0);
}
void CBurnPlugin::OnCbnDropdownSpeed()
{
	__int32 nSize=20;
	SetCapture();
	BeginWaitCursor();
	SSpeed Speeds[20];
	FoxBurner::GetPossibleBurnSpeeds(Speeds,&nSize);
	CString strSpeed;

	m_ctrlSpeed.ResetContent();
	for(int i=0;i<nSize;++i)
	{
		strSpeed.Format(_T("%.1f"),Speeds[i].fSpeed);
		m_ctrlSpeed.SetItemData(m_ctrlSpeed.InsertString(0,strSpeed),Speeds[i].nSpeedInKBPerSec);
	}
	strSpeed = GetGUIText(BS_SDK_MESSAGE_12);
	m_ctrlSpeed.SetItemData(m_ctrlSpeed.AddString(strSpeed),BS_MAX_SPEED);
	__int32 nSpeed;

	FoxBurner::GetBurnSpeed(&nSpeed);
	if (0 < nSpeed)
	{
		strSpeed.Format(_T("%dx"), nSpeed);
	}
	else
	{
		strSpeed = GetGUIText(BS_SDK_MESSAGE_12);
		FoxBurner::SetBurnSpeed(BS_MAX_SPEED);
	}
	if (CB_ERR == m_ctrlSpeed.SetCurSel(m_ctrlSpeed.FindStringExact(-1, strSpeed)))
	{
		m_ctrlSpeed.SetCurSel(m_ctrlSpeed.FindStringExact(-1, GetGUIText(BS_SDK_MESSAGE_12)));
		FoxBurner::SetBurnSpeed(BS_MAX_SPEED);
	}
	ReleaseCapture();
	EndWaitCursor();
}
//##########################################################
//Function to get and Format time for Log Handling
//##########################################################
void CBurnPlugin::OnLogEvent(CString nString, int isError){
	CString ntimus;
	int thisIndex = 0;


	TCHAR timus[256];
	time_t zeit;
	time(&zeit);
	wcsftime(timus,99,_T(" %X"),localtime(&zeit));

	ntimus.Format(_T("%s"),timus);

	thisIndex += isError;

	int lItems = m_cListLog.GetItemCount();
	m_cListLog.InsertItem(LVIF_IMAGE | LVIF_TEXT, lItems, _T(""), LVIS_SELECTED , LVIS_SELECTED, thisIndex, 0);
	m_cListLog.SetItemText(lItems,1,ntimus);
	m_cListLog.SetItemText(lItems,2,nString);

	//m_cListLog.ScrollWindow(
	m_cListLog.SetItemState(lItems,LVIS_SELECTED,LVIS_SELECTED|LVIS_FOCUSED);
	m_cListLog.EnsureVisible(lItems,TRUE);


}

void CBurnPlugin::DoBurnNow()
{
	__int32 nError;
	CString sBurn;
	//Deactivatet he Log Save Button to avoid crashes
	this->GetDlgItem(IDC_LOGSAVE)->EnableWindow(FALSE);

	//Check if something was selected
	cBurnFolder.GetWindowText(sBurn);
	if(sBurn.GetLength()<3){
		OnLogEvent(GetText(MESSAGE_11),0);  //Succefull reseted
		return;
	}

	//First we clear all the Files/Folders and Settings according to the project.
	FoxBurner::ClearAll();

	//--------------------------------------------------
	//GUI Burn. Set Burndevice
	//--------------------------------------------------
	int index = cbDevice.GetCurSel();
	if (index != CB_ERR) {

		TCHAR drive[256];
		cbDevice.GetLBText(index, drive);

		__int32 nError = FoxBurner::SetDevice(drive[0]);
		handleError(nError);
	}
	//BurnDevice
	CString xDevice;
	cbDevice.GetWindowText(xDevice);
	OnLogEvent(_T("Selected Device: " + xDevice),1);  //Succefull reseted


	//Set the BurnOptions
	SOptions OTmp;
	FoxBurner::GetOptions(&OTmp);
	OTmp.bEjectAfterBurn = xOpt1.GetCheck();
	OTmp.bFinalize = xOpt3.GetCheck();
	OTmp.bUnderrunProtection = xOpt2.GetCheck();
	nError = FoxBurner::SetOptions(OTmp);
	if(nError != BS_SDK_ERROR_NO){
		handleError(nError); //Ups, error
		return;
	}
	else{
		OnLogEvent(_T("Burn Options setted successfull."),1);  //Succefull reseted
		if(xOpt1.GetCheck()==0)
			OnLogEvent(_T("----Eject after Burn deactivated"),2);
		else
			OnLogEvent(_T("----Eject after Burn activated"),1);
		if(xOpt3.GetCheck()==0)
			OnLogEvent(_T("----Finalize Disc deactivated"),2);
		else
			OnLogEvent(_T("----Finalize Disc activated"),1);
		if(xOpt2.GetCheck()==0)
			OnLogEvent(_T("----Buffer Underrun protection deactivated"),2);
		else
			OnLogEvent(_T("----Buffer Underrun protection activated"),1);
	}

	//Set Label
	CString m_disclabel;
	m_strVolumeLabel.GetWindowText(m_disclabel);
	CStringToAnsi(m_disclabel.GetBuffer(m_disclabel.GetLength()),OTmp.chVolumeLabel);
	m_disclabel.ReleaseBuffer();
	nError = FoxBurner::SetOptions(OTmp);
	if(nError != BS_SDK_ERROR_NO){
		handleError(nError); //Ups, error
		return;
	}else
		OnLogEvent(_T("Set disclabel: " + m_disclabel),1);  //Succefull reseted

	//Get Speed


	//AddDir. Get Dir and check what type of Folder
	int setBits = 0;


	CString folder = sBurn.Mid(sBurn.ReverseFind('\\') + 1);
	SDirToAdd dir;

	dir.lpszSourceDirPath = (LPCTSTR)sBurn;
	//swprintf(dir.lpszSourceDirPath, sBurn.GetBuffer(sBurn.GetLength()));
	//wsprintf(dir.lpszSourceDirPath, sBurn.GetBuffer(sBurn.GetLength()));
	//sBurn.ReleaseBuffer();

	if (folder.CollateNoCase(_T("Video_Ts")) == 0) {
		//swprintf(dir.lpszDestinationPath, _T("\\"));
		dir.lpszDestinationPath = _T("\\");
		dir.nSavePath = BS_PARENTDIR_ONLY;
		setBits = 0;
	} else {
		//swprintf(dir.lpszDestinationPath, _T("\\VIDEO_TS\\"));
		dir.lpszDestinationPath = _T("\\VIDEO_TS\\");
		dir.nSavePath = BS_DONT_SAVE_PATH;
		setBits = 1;
	}

	dir.lpszFileSpecification = _T("*.*");
	//swprintf(dir.lpszFileSpecification, _T("*.*"));
	dir.nFileAttributes = BS_FA_All;
	dir.bRecursive = BS_FALSE;

	//Finaly call AddDIr
	nError = FoxBurner::AddDir(dir);
	if(nError != BS_SDK_ERROR_NO){
		handleError(nError); //Ups, error
		OnLogEvent(_T("----Folder: " + sBurn),0); //Give Folder to Log, important for Support
		return;
	}
	else
		OnLogEvent(_T("Folder added successfull: " + sBurn),1); //Succesfull added

	//Important for Support Requests
	if(setBits==0)
		OnLogEvent(_T("----Added with: BS_PARENTDIR_ONLY"),1); //Succesfull added
	else
		OnLogEvent(_T("----Added with: BS_DONT_SAVE_PATH"),1); //Succesfull added

	//Ok, no prepare the Image
	nError = FoxBurner::Prepare();
	if(nError != BS_SDK_ERROR_NO){
		handleError(nError); //Ups, error
		return;
	}
	else
		OnLogEvent(_T("Image succefull perpared. Ready to burn now."),1); //Succesfull added

	nError = FoxBurner::Burn();
	if(nError != BS_SDK_ERROR_NO){
		handleError(nError); //Ups, error
		return;
	}
	else
		OnLogEvent(_T("Start Burning now..."),1); //Succesfull added

	OnControlSwitch(FALSE);
	nTimercounter = 0;
	onWork = true;
	SetTimer(1099,1000,NULL);
	this->GetDlgItem(IDC_STARTBUT)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_STOPBUT)->EnableWindow(TRUE);
	this->GetDlgItem(IDC_LOGSAVE)->EnableWindow(FALSE);




}
//##########################################################
//Error Handling Function. Get the Text behind the Errorcodes
//##########################################################
void CBurnPlugin::handleError(__int32 errCode)
{
	if (errCode != BS_SDK_ERROR_NO)
	{
		TCHAR chError[2048];
		CString chErrorDesc;
		__int32 nLength = 2048;

		FoxBurner::GetText(errCode, chError, &nLength);
		chErrorDesc.Format( _T("%s"), chError);
		OnLogEvent(chErrorDesc,0);
		this->GetDlgItem(IDC_LOGSAVE)->EnableWindow(TRUE);
		onWork = false;
		KillTimer(1099);
	}
}
void CBurnPlugin::OnBnClickedStartbut()
{
	m_cListLog.DeleteAllItems();
	DoBurnNow();
}
//##########################################################
//Activate/Deactivate the Controls to avoid Errors
//##########################################################
void CBurnPlugin::OnControlSwitch(BOOL bActivate)
{
	this->GetDlgItem(IDC_BURNFOLDER)->EnableWindow(bActivate);
	this->GetDlgItem(IDC_OPENSOURCE)->EnableWindow(bActivate);
	this->GetDlgItem(IDC_VOLUMELABEL)->EnableWindow(bActivate);
	this->GetDlgItem(IDC_DEVICE)->EnableWindow(bActivate);
	this->GetDlgItem(IDC_SPEED)->EnableWindow(bActivate);
	this->GetDlgItem(IDC_OPT1)->EnableWindow(bActivate);
	this->GetDlgItem(IDC_OPT2)->EnableWindow(bActivate);
	this->GetDlgItem(IDC_BERASE)->EnableWindow(bActivate);
}

void CBurnPlugin::OnBnClickedLogsave()
{
	OPENFILENAME ofn;
	TCHAR szFile[MAX_PATH];
	LVITEM lvi;
	TCHAR szBuffer[1024];
	DWORD cchBuf(1024);
	CString eintrag;

	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = this->m_hWnd;
	ofn.lpstrFile = szFile;
	ofn.lpstrFile[0] = '\0';
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = _T("Log Files (*.log)\0*.log\0");
	ofn.nFilterIndex = 0;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_EXPLORER;

	if (GetSaveFileName(&ofn) == TRUE) {
		CStdioFile f(szFile, CFile::modeCreate | CFile::modeWrite | CFile::shareExclusive);
		for(int i = 0; i < m_cListLog.GetItemCount(); i++)
		{
			lvi.iItem = i;
			lvi.iSubItem = 0;
			lvi.mask = LVIF_IMAGE | LVIF_TEXT;
			lvi.pszText = szBuffer;
			lvi.cchTextMax = cchBuf;

			m_cListLog.GetItem(&lvi);
			if(lvi.iImage==0){
				eintrag = _T("Error :: ");
			}else{
				eintrag = _T("Info  :: ");
			}
			eintrag += m_cListLog.GetItemText(i,1);
			eintrag += _T(" :: ");
			eintrag += m_cListLog.GetItemText(i,2);

			f.WriteString(eintrag);

			f.WriteString(_T("\n"));
		} /* write each */
		f.Close();
	}
}

void CBurnPlugin::OnBnClickedBerase()
{
	__int32 nError = FoxBurner::EraseDialog(_T("ShrinkTo5 Plugin"));
	if(nError != BS_SDK_ERROR_NO){
		handleError(nError); //Ups, error
	}

}

/*****************************************************************************
 * FillMultiLangGui
 * Set the new Static Text
 *****************************************************************************/
void CBurnPlugin::FillMultiLangGui()
{
	this->GetDlgItem(IDC_HEADERA1)->SetWindowText(GetText(HEADER_6));
	this->GetDlgItem(IDC_HEADERA2)->SetWindowText(GetText(HEADER_7));
	this->GetDlgItem(IDC_HEADERA3)->SetWindowText(GetText(HEADER_12));
	this->GetDlgItem(IDC_HEADERA4)->SetWindowText(GetText(HEADER_9));
	this->GetDlgItem(IDC_HEADERA5)->SetWindowText(GetText(HEADER_10));
	this->GetDlgItem(IDC_HEADERA6)->SetWindowText(GetText(HEADER_11));
	this->GetDlgItem(IDC_HEADERA7)->SetWindowText(GetText(HEADER_8));
	this->GetDlgItem(IDC_BERASE)->SetWindowText(GetText(GUI_7));
	this->GetDlgItem(IDC_LOGSAVE)->SetWindowText(GetText(GUI_8));
	this->GetDlgItem(IDC_OPT1)->SetWindowText(GetText(GUI_4));
	this->GetDlgItem(IDC_OPT2)->SetWindowText(GetText(GUI_5));
	this->GetDlgItem(IDC_OPT3)->SetWindowText(GetText(GUI_6));

	m_ToolTip.AddTool(&bErase,GetText(BURN_2));
	m_ToolTip.AddTool(&bSource,GetText(TOOL_8));
	m_ToolTip.AddTool(&bSaveLog,GetText(TOOL_7));
	m_ToolTip.AddTool(&m_bStart,GetText(BURN_1));
	m_ToolTip.AddTool(&xHeader,GetText(MIX_1));

	LVCOLUMN lvCol;
	CString temp;
	::ZeroMemory((void *)&lvCol, sizeof(LVCOLUMN));
	lvCol.mask=LVCF_TEXT;
	temp = GetText(GUI_9);
	 m_cListLog.GetColumn(1,&lvCol);
	lvCol.pszText = temp.GetBuffer(temp.GetLength());
	temp.ReleaseBuffer();
	 m_cListLog.SetColumn(1,&lvCol);
	::ZeroMemory((void *)&lvCol, sizeof(LVCOLUMN));
	lvCol.mask=LVCF_TEXT;
	temp = GetText(GUI_10);
	 m_cListLog.GetColumn(2,&lvCol);
	lvCol.pszText = temp.GetBuffer(temp.GetLength());
	temp.ReleaseBuffer();
	 m_cListLog.SetColumn(2,&lvCol);


	FoxBurner::SetLanguage(LangID,EncLangFile);
	RedrawWindow();

}

BOOL CBurnPlugin::PreTranslateMessage(MSG* pMsg)
{
	m_ToolTip.RelayEvent(pMsg);

	return CBDialog::PreTranslateMessage(pMsg);
}

LRESULT CBurnPlugin::OnBurnDone(WPARAM wParam, LPARAM lParam)
{
	onWork = false;
	KillTimer(1099);
	this->OnControlSwitch(TRUE);
	this->GetDlgItem(IDC_STARTBUT)->EnableWindow(TRUE);
	this->GetDlgItem(IDC_STOPBUT)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_LOGSAVE)->EnableWindow(TRUE);
	CString s_zeit;
	s_zeit.Format(_T("%02d:%02d:%02d"),(int)(nTimercounter / 3600), (int)((nTimercounter % 3600) / 60), (int)(nTimercounter % 60));
	OnLogEvent(_T("Total time: ") + s_zeit,1); //Succesfull added

	return 0;
}

void CBurnPlugin::OnBnClickedStopbut()
{
	FoxBurner::Abort();
	onWork = false;
	KillTimer(1099);
	OnControlSwitch(TRUE);
	OnLogEvent(_T("Canceled by user."),1); //Succesfull added
	this->GetDlgItem(IDC_STARTBUT)->EnableWindow(TRUE);
	this->GetDlgItem(IDC_STOPBUT)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_LOGSAVE)->EnableWindow(FALSE);
}

void CBurnPlugin::OnTimer(UINT nIDEvent)
{
	nTimercounter++;

	CBDialog::OnTimer(nIDEvent);
}
