#pragma once
#include "./GUI/BDialog.h"
#include "./GUI/xSkinButton.h"
#include "./GUI/TransparentButton.h"
#include "afxwin.h"
#include "afxcmn.h"

// CBurnPlugin-Dialogfeld

class CBurnPlugin : public CBDialog
{
	DECLARE_DYNAMIC(CBurnPlugin)

public:
	CBurnPlugin(CWnd* pParent = NULL);   // Standardkonstruktor
	virtual ~CBurnPlugin();

// Dialogfelddaten
	enum { IDD = IDD_BURN };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	CImageList m_LogIcons;

	DECLARE_MESSAGE_MAP()
public:
	//Default MFC Widgets
	CStatic xHeader;
	CButton bSaveLog;
	CProgressCtrl m_burnprogress;
	CComboBox cbDevice;
	CComboBox m_ctrlSpeed;
	CEdit m_strVolumeLabel;
	CEdit cBurnFolder;
	CListCtrl m_cListLog;
	CToolTipCtrl m_ToolTip;
	//Own Widgets
	CxSkinButton bErase;
	CxSkinButton m_bStop;
	CxSkinButton m_bStart;
	CxSkinButton bSource;
	CxSkinButton mOptBut;
	CTransparentButton xOpt1;
	CTransparentButton xOpt2;
	CTransparentButton xOpt3;
	//Vars
	CFont new_font;
	int nTimercounter;
	bool onWork;
	//afx_msg
	afx_msg LRESULT OnBurnDone(WPARAM wParam, LPARAM lParam);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnBnClickedStopbut();
	afx_msg void OnBnClickedBerase();
	afx_msg void OnBnClickedLogsave();
	afx_msg void OnBnClickedStartbut();
	afx_msg void OnBnClickedOpensource();
	afx_msg void OnCbnSelchangeSpeed();
	afx_msg void OnCbnDropdownSpeed();
	afx_msg void OnCbnSelchangeDevice();
	afx_msg void OnBnClickedOptbut();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//Virtuals
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnInitDialog();
	//Own Functions
	void FillMultiLangGui();
	void OnLogEvent(CString nString, int isError);
	void DoBurnNow();
	void handleError(__int32 errCode);
	void FillDrives();	
	void SetSpeedCombo(void);
	void OnControlSwitch(BOOL bActivate);
};
