// DoShrink.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "ShrinkTo5Gui.h"
#include "DoShrink.h"
#include ".\doshrink.h"
#include "UnicodeHelpers.h"

unsigned __stdcall WorkingThread(void *pDVDDlg);
// CShrinkTo5GuiDlg Dialogfeld

IMPLEMENT_DYNAMIC(CDoShrink, CDialog)
CDoShrink::CDoShrink(CWnd* pParent /*=NULL*/)
	: CBDialog(CDoShrink::IDD, pParent)
{
	threadHandle = 0;
	onWork = false;
}

CDoShrink::~CDoShrink()
{
}

void CDoShrink::DoDataExchange(CDataExchange* pDX)
{
	CBDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DVDTREE, VTSTree);
	DDX_Control(pDX, IDC_PROSETTINGS, xDown);
	DDX_Control(pDX, IDC_DEPOSITE, xDeposite);
	DDX_Control(pDX, IDC_SPEEDB, xSpeedB);
	DDX_Control(pDX, IDC_SOURCE, cInputFile);
	DDX_Control(pDX, IDC_TARGET, cOutputFile);
	DDX_Control(pDX, IDC_OPENSOURCE, m_bSource);
	DDX_Control(pDX, IDC_OPENTARGET, m_bTarget);
	DDX_Control(pDX, IDC_STDAUD, stdAud);
	DDX_Control(pDX, IDC_STDSUB, stdSub);
	DDX_Control(pDX, IDC_STARTBUT, m_bStart);
	DDX_Control(pDX, IDC_STOPBUT, m_bStop);
	DDX_Control(pDX, IDC_COOL_SLIDER, mSlider);
	DDX_Control(pDX, IDC_SLIDERTEXT, mTargetGB);
	DDX_Control(pDX, IDC_MOVIEONLY, movieOnly);
	DDX_Control(pDX, IDC_WHOLEDVD, wholeDVD);
	DDX_Control(pDX, IDC_CUSTOM, customDVD);
}


BEGIN_MESSAGE_MAP(CDoShrink, CBDialog)
	ON_WM_CTLCOLOR()
	ON_WM_HSCROLL()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_OPENSOURCE, OnBnClickedOpensource)
	ON_BN_CLICKED(IDC_OPENTARGET, OnBnClickedOpentarget)
	ON_BN_CLICKED(IDC_STOPBUT, OnBnClickedStopbut)
	ON_BN_CLICKED(IDC_MOVIEONLY, OnBnClickedMovieonly)
	ON_BN_CLICKED(IDC_WHOLEDVD, OnBnClickedWholedvd)
	ON_BN_CLICKED(IDC_CUSTOM, OnBnClickedCustom)
	ON_BN_CLICKED(IDC_STARTBUT, OnBnClickedStartbut)
	ON_BN_CLICKED(IDC_PROSETTINGS, OnBnClickedProsettings)
END_MESSAGE_MAP()


// CDoShrink-Meldungshandler

BOOL CDoShrink::OnInitDialog()
{
	CBDialog::OnInitDialog();


	//Build Dialog With Background Bitmap
	SetBitmapStyle(StyleCenter);
	SetBitmap(IDB_SHRINKBG);

	VERIFY(smallWindow.Create(CWorkWindow::IDD, this));
	smallWindow.ShowWindow(SW_HIDE);
	smallWindow.opener = this;

	//Set Progressbar defaults
	smallWindow.m_burnprogress.SetRange(0,100);
	smallWindow.m_burnprogress.SetPos(0);	
	smallWindow.FillMultiLangGui();

	//Build our custom Slider and set the default settings
	mSlider.SetSliderGeneral(1,&mTargetGB);
	mSlider.SetRange(2000, 7500);
	mSlider.SetPos(4482);

	FillMultiLangGui();

	//Paint all Header in dark grey/bold
    LOGFONT new_logfont; 	
	GetDlgItem(IDC_HEADER1)->GetFont()->GetLogFont(&new_logfont); 
	new_logfont.lfWeight = FW_BOLD;
	new_font.CreateFontIndirect(&new_logfont); 
	GetDlgItem(IDC_HEADER1)->SetFont(&new_font);
	GetDlgItem(IDC_HEADER2)->SetFont(&new_font);
	GetDlgItem(IDC_HEADER3)->SetFont(&new_font);
	GetDlgItem(IDC_HEADER4)->SetFont(&new_font);
	GetDlgItem(IDC_HEADER5)->SetFont(&new_font);

	//Create and attach Tooltips
	if(m_ToolTip.Create(this))
	{
		m_ToolTip.SetDelayTime(TTDT_INITIAL,10);
		m_ToolTip.AddTool(&m_bSource,GetText(TOOL_1));
		m_ToolTip.AddTool(&m_bTarget,GetText(TOOL_2));
		m_ToolTip.AddTool(&m_bStart,GetText(TOOL_3));
		m_ToolTip.AddTool(&m_bStop,GetText(TOOL_4));
		m_ToolTip.AddTool(&mSlider,GetText(TOOL_5));
		m_ToolTip.AddTool(&xDeposite,GetText(TOOL_9));
		m_ToolTip.AddTool(&xSpeedB,GetText(TOOL_10));
		m_ToolTip.Activate(TRUE);
	}

	//Set the Bitmap Skins to the Button controls
	m_bSource.SetSkin(IDB_BUTTON, 1, 1, 1, 0, 0, 0, 0);
	m_bTarget.SetSkin(IDB_BUTTON, 1, 1, 1, 0, 0, 0, 0);
	m_bStart.SetSkin(IDB_START, 1, 1, 1, 0, 0, 0, 0);
	m_bStop.SetSkin(IDB_STOP, 1, 1, 1, 0, 0, 0, 0);
	xDown.SetSkin(IDB_DOWN, 0, 0, 0, 0, 0, 0, 0);

	//Set Start and Stop Button to deactivate
	m_bStop.EnableWindow(FALSE);
	m_bStart.EnableWindow(FALSE);
	xDown.SetCheck(0);

	//Make Targetsize settings
	targetSizeGB = (float)((int)(((float)4482 / 1024) * 100)) / 100;
	mTemp.Format(_T("%.2f GB"),targetSizeGB);
	mTargetGB.SetWindowText(mTemp);
	DVDTransfer.SetTargetSizeMB(4482);

	//Initial the MltTree TreeView Control and attach Bitmaps to it.
	VTSTree.InitBitmaps();

	// bind alert object to transfer
	DVDTransfer.SetAlert(&alert);
	alert.AddAlert(ALERT_PREVIEW_AVAIL);
	alert.SetPreviewDC(smallWindow.cPreview.GetDC()->GetSafeHdc());
	alert.SetBitmapStatic(&smallWindow.cPreview);	

	movieOnly.EnableWindow(FALSE);
	wholeDVD.EnableWindow(FALSE);
	customDVD.EnableWindow(FALSE);
	stdAud.EnableWindow(FALSE);
	stdSub.EnableWindow(FALSE);
	VTSTree.EnableWindow(FALSE);
	
	DVDTransfer.SetMovieOnly(false);

	return TRUE;  // return TRUE unless you set the focus to a control
	// AUSNAHME: OCX-Eigenschaftenseite muss FALSE zurckgeben.
}

HBRUSH CDoShrink::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CBDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if (pWnd->GetDlgCtrlID() == IDC_HEADER1 || pWnd->GetDlgCtrlID() == IDC_HEADER2  || pWnd->GetDlgCtrlID() == IDC_HEADER3 || pWnd->GetDlgCtrlID() == IDC_HEADER4 || pWnd->GetDlgCtrlID() == IDC_HEADER5)
		{      
		pDC->SetTextColor(RGB(102,102,102)); //Textfarbe 
		pDC->SetBkMode(TRANSPARENT);
		return (HBRUSH)GetStockObject(NULL_BRUSH);
		}
	if (pWnd->GetDlgCtrlID() == IDC_SLIDERTEXT )
		{      
		pDC->SetBkMode(TRANSPARENT);
		return (HBRUSH)GetStockObject(NULL_BRUSH);
		}

	if (pWnd->GetDlgCtrlID() == IDC_MOVIEONLY || pWnd->GetDlgCtrlID() == IDC_WHOLEDVD || pWnd->GetDlgCtrlID() == IDC_CUSTOM || pWnd->GetDlgCtrlID() == IDC_DEPOSITE || pWnd->GetDlgCtrlID() == IDC_SPEEDB){
		RECT rc;


		pDC->SetBkMode(TRANSPARENT);

		HBRUSH hBrush = (HBRUSH)GetProp(pWnd->m_hWnd, PROP_HBRUSH); 
		if(hBrush )
		{			
			return hBrush;
		}

		return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
	}

	return hbr;
}

void CDoShrink::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	targetSizeGB = (float)((int)(((float)mSlider.GetPos() / 1024) * 100)) / 100;
	mTemp.Format(_T("%.2f GB"),targetSizeGB);
	mTargetGB.SetWindowText(mTemp);
	
	CRect rect;
	mTargetGB.GetWindowRect(&rect);
	ScreenToClient(rect);
	InvalidateRect(&rect,1);
	UpdateWindow();

	DVDTransfer.SetTargetSizeMB(mSlider.GetPos());

	CBDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CDoShrink::OnBnClickedOpensource()
{
	//--------------------------------------------------
	//API Folder Selectdialog
	//--------------------------------------------------
	BROWSEINFO		info;
	LPITEMIDLIST	selectedFolder;
	CString wTitle = GetText(GUI_1);

	TCHAR displayName[MAX_PATH];
	TCHAR selectedPath[MAX_PATH];
	
	info.hwndOwner = this->m_hWnd;
	info.pidlRoot = NULL;
	info.pszDisplayName = displayName;
	info.lpszTitle = wTitle.GetBuffer(); //GUI_1
	wTitle.ReleaseBuffer();
	info.ulFlags = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
	info.lpfn = NULL;
	info.lParam = NULL;
	info.iImage = 0;

	selectedFolder = SHBrowseForFolder(&info);

	if (selectedFolder != NULL) {
		if (SHGetPathFromIDList(selectedFolder, selectedPath)) {

			cInputFile.SetWindowText(selectedPath);
			OnOpenImage();
		}
	}
}

void CDoShrink::OnBnClickedOpentarget()
{
	//--------------------------------------------------
	//API Folder Selectdialog
	//--------------------------------------------------
	BROWSEINFO		info;
	LPITEMIDLIST	selectedFolder;
	CString wTitle = GetText(GUI_2);

	TCHAR displayName[MAX_PATH];
	TCHAR selectedPath[MAX_PATH];
	
	info.hwndOwner = this->m_hWnd;
	info.pidlRoot = NULL;
	info.pszDisplayName = displayName;
	info.lpszTitle = wTitle.GetBuffer(); //GUI_2
	wTitle.ReleaseBuffer();
	info.ulFlags = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
	info.lpfn = NULL;
	info.lParam = NULL;
	info.iImage = 0;

	selectedFolder = SHBrowseForFolder(&info);

	if (selectedFolder != NULL) {
		if (SHGetPathFromIDList(selectedFolder, selectedPath)) {

			cOutputFile.SetWindowText(selectedPath);
		}
	}
}

/*****************************************************************************
* Stop the main thread
*****************************************************************************/
void CDoShrink::OnBnClickedStopbut()
{
	SetCapture();
	BeginWaitCursor();
	m_bStop.EnableWindow(FALSE);
	m_bStart.EnableWindow(TRUE);
	threadHandle = 0;
	onWork = false;
	stopFlag = 1;
}

void CDoShrink::OnBnClickedMovieonly()
{
	DVDTransfer.SetMovieOnly(true);
	VTSTree.DeleteAllItems();
	ReleaseVTSTreeView();
	VTSTree.EnableWindow(TRUE);
	stdAud.EnableWindow(TRUE);
	stdSub.EnableWindow(TRUE);
}

void CDoShrink::OnBnClickedWholedvd()
{
	DVDTransfer.SetMovieOnly(false);
	VTSTree.DeleteAllItems();
	ReleaseVTSTreeView();
	VTSTree.EnableWindow(FALSE);
	stdAud.EnableWindow(FALSE);
	stdSub.EnableWindow(FALSE);
}

void CDoShrink::OnBnClickedCustom()
{
	DVDTransfer.SetMovieOnly(false);
	VTSTree.DeleteAllItems();
	ReleaseVTSTreeView();
	VTSTree.EnableWindow(TRUE);
	stdAud.EnableWindow(FALSE);
	stdSub.EnableWindow(FALSE);
}
/*****************************************************************************
* Fill the treeview
*****************************************************************************/
void CDoShrink::ReleaseVTSTreeView(){
	int i;

	// if movie only is selected, show only biggest VTS
	if(movieOnly.GetCheck() == BST_CHECKED)
	{
		int movieVTS = -1, movieSize = -1;

		for(i = 0; i < DVDTransfer.GetNumVTS(); i++)
		{
			if(DVDTransfer.GetVTSSize(i) > movieSize)
			{
				movieSize = DVDTransfer.GetVTSSize(i);
				movieVTS = i;
			}
		}

		InsertVTSTreeItem(movieVTS);
		VTSTree.SelectSetFirstVisible(currVTS[movieVTS]);
	}
	// else populate with all VTS
	else
	{
		for(i = 0; i < DVDTransfer.GetNumVTS(); i++)
		{
			InsertVTSTreeItem(i);
		}

		VTSTree.SelectSetFirstVisible(currVTS[0]);
	}

	m_bStart.EnableWindow(TRUE);
}

/*****************************************************************************
* Get deeper to fill the treeview
*****************************************************************************/
void CDoShrink::InsertVTSTreeItem(int i)
{
	TCHAR desc[256];
	char myDesc[256];

	TVINSERTSTRUCT tvi;
	int j;

	tvi.hParent = TVI_ROOT;
	tvi.hInsertAfter = TVI_LAST;
	tvi.itemex.mask = TVIF_PARAM | TVIF_TEXT;
	tvi.itemex.lParam = 0;
	tvi.itemex.pszText = desc;
	tvi.itemex.cchTextMax = 256;

	if(i == 0){
		swprintf(desc, _T("%s (%dMB)"),GetText(TREE_1), DVDTransfer.GetVTSSize(i)); 
		currVTS[i] = VTSTree.InsertItem(3,1,0,desc,TVI_ROOT);
		VTSTree.SetItemData(currVTS[i],0);
	}else{
		swprintf(desc, _T("%s %d (%dMB)"),GetText(TREE_2), i, DVDTransfer.GetVTSSize(i)); 
		currVTS[i] = VTSTree.InsertItem(0,1,0,desc,TVI_ROOT);
		VTSTree.SetItemData(currVTS[i],0);
	}
	//currVTS[i] = VTSTree.InsertItem(&tvi);

	while(stdAud.DeleteString(0) > 0);
	while(stdSub.DeleteString(0) > 0);

	// list audio stremas
	if(DVDTransfer.GetNumVTSLang(i) > 0)
	{
		HTREEITEM currItem;
		tvi.hParent = currVTS[i];
		swprintf(desc, GetText(TREE_3)); 
		if(i==0){
			currItem = VTSTree.InsertItem(5,1,0,desc,currVTS[i]);
			VTSTree.SetItemData(currItem,0);
		}else{
			currItem = VTSTree.InsertItem(1,1,0,desc,currVTS[i]);
			VTSTree.SetItemData(currItem,0);
		}


		if(movieOnly.GetCheck() == BST_CHECKED)
		{
			sprintf(myDesc, "none");
			stdAud.InsertString(-1, AnsiToCString(myDesc,256));
			stdAud.SetItemData(0, -1);
		}

		tvi.hParent = currItem;
		for(j = 0; j < DVDTransfer.GetNumVTSLang(i); j++)
		{
			HTREEITEM subItem;
			
			DVDTransfer.GetVTSLangDesc(i, j, myDesc, 256);
			subItem = VTSTree.InsertItem(6,8,true,AnsiToCString(myDesc,256),currItem);
			VTSTree.SetItemData(subItem,(i << 24) + (1 << 16) + (j << 8));
			
			//DVDTransfer.GetVTSLangDesc(i, j, desc, 256);
			//tvi.itemex.lParam = (i << 24) + (1 << 16) + (j << 8);
			//HTREEITEM item = VTSTree.InsertItem(&tvi);
			//VTSTree.SetCheck(item);
			// fill audio streams into standard audio combo
			if(movieOnly.GetCheck() == BST_CHECKED)
			{
				stdAud.InsertString(-1, AnsiToCString(myDesc,256));
				stdAud.SetItemData(j + 1, j);
			}
		}
		VTSTree.Expand(currItem, TVE_EXPAND);

		if(movieOnly.GetCheck() == BST_CHECKED)	{ stdAud.SetCurSel(1); }
	}

	// list subpicture streams
	if(DVDTransfer.GetNumVTSSub(i) > 0)
	{
		HTREEITEM currItem;
		tvi.hParent = currVTS[i];
		tvi.itemex.lParam = 0;
		swprintf(desc, GetText(TREE_4)); 
		if(i==0){
			currItem = VTSTree.InsertItem(4,1,0,desc,currVTS[i]);
			VTSTree.SetItemData(currItem,0);
		}else{
			currItem = VTSTree.InsertItem(2,1,0,desc,currVTS[i]);
			VTSTree.SetItemData(currItem,0);
		}

		if(movieOnly.GetCheck() == BST_CHECKED)
		{
			sprintf(myDesc, "none");
			stdSub.InsertString(-1, AnsiToCString(myDesc,256));
			stdSub.SetItemData(0, -1);
		}

		tvi.hParent = currItem;
		for(j = 0; j < DVDTransfer.GetNumVTSSub(i); j++)
		{
			HTREEITEM subItem;
			DVDTransfer.GetVTSSubDesc(i, j, myDesc, 256);
			subItem = VTSTree.InsertItem(6,6,true,AnsiToCString(myDesc,256),currItem);
			VTSTree.SetItemData(subItem,(i << 24) + (2 << 16) + (j << 8));

			// fill subpicture streams into standard audio combo
			if(movieOnly.GetCheck() == BST_CHECKED)
			{
				stdSub.InsertString(-1, AnsiToCString(myDesc,256));
				stdSub.SetItemData(j + 1, j);
			}
		}
		VTSTree.Expand(currItem, TVE_EXPAND);
		if(movieOnly.GetCheck() == BST_CHECKED)	{ stdSub.SetCurSel(0); }
	}

	VTSTree.Expand(currVTS[i], TVE_EXPAND);
}

/*****************************************************************************
* Get selected/deselected streams and give them to the ShrinkTo5 Engine
*****************************************************************************/
void CDoShrink::ReadVTSTree()
{
	int i;

	// if movie only is selected, get the only only VTS shown
	if(movieOnly.GetCheck() == BST_CHECKED)
	{
		int movieVTS = -1, movieSize = -1;

		for(i = 0; i < DVDTransfer.GetNumVTS(); i++)
		{
			if(DVDTransfer.GetVTSSize(i) > movieSize)
			{
				movieSize = DVDTransfer.GetVTSSize(i);
				movieVTS = i;
			}
		}

		ReadVTSTreeItem(movieVTS);
	}
	// else read all VTS
	else
	{
		for(i = 0; i < DVDTransfer.GetNumVTS(); i++)
		{
			ReadVTSTreeItem(i);
		}
	}
}

/*****************************************************************************
* Get deeper in the Treeview
*****************************************************************************/
void CDoShrink::ReadVTSTreeItem(int i)
{
	HTREEITEM audio, subs;

	// if there are audio/languages
	if(DVDTransfer.GetNumVTSLang(i) > 0)
	{
		audio = VTSTree.GetChildItem(currVTS[i]);
		_ASSERT(audio != NULL);

		HTREEITEM currItem = VTSTree.GetChildItem(audio);

		// read languages
		if(currItem != NULL)
		{
			do
			{
				int param = VTSTree.GetItemData(currItem);
				int VTS  = (param >> 24) & 0xFF;
				int num  = (param >> 8) & 0xFF;
				int check = VTSTree.IsItemChecked(currItem);
				if(check != 0) check = 1;
				DVDTransfer.SetVTSLangSelected(VTS, num, check);
			} while((currItem = VTSTree.GetNextItem(currItem, TVGN_NEXT)) != NULL);
		}

		// read standard language
		if(movieOnly.GetCheck() == BST_CHECKED)
		{
			int sel = stdAud.GetCurSel();
			int lang = stdAud.GetItemData(sel);
			DVDTransfer.SetVTSLangDefault(i, lang);
		}
	}

	// if there are subs
	if(DVDTransfer.GetNumVTSSub(i) > 0)
	{
		if(DVDTransfer.GetNumVTSLang(i) > 0) subs  = VTSTree.GetNextItem(audio, TVGN_NEXT);
		else								 subs  = VTSTree.GetChildItem(currVTS[i]);
		_ASSERT(subs != NULL);

		HTREEITEM currItem = VTSTree.GetChildItem(subs);

		// read subs
		if(currItem != NULL)
		{
			do
			{
				int param = VTSTree.GetItemData(currItem);
				int VTS  = (param >> 24) & 0xFF;
				int num  = (param >> 8) & 0xFF;
				int check = VTSTree.IsItemChecked(currItem);
				if(check != 0) check = 1;
				DVDTransfer.SetVTSSubSelected(VTS, num, check);
			} while((currItem = VTSTree.GetNextItem(currItem, TVGN_NEXT)) != NULL);
		}

		// read standard subpicture
		if(movieOnly.GetCheck() == BST_CHECKED)
		{
			int sel = stdSub.GetCurSel();
			int lang = stdSub.GetItemData(sel);
			DVDTransfer.SetVTSSubDefault(i, lang);
		}
	}
}

/*****************************************************************************
* Ready to start. Check everything, set the streams and start thread
*****************************************************************************/
void CDoShrink::OnBnClickedStartbut()
{
	CString input;
	cOutputFile.GetWindowText(input);

	if(input.GetLength()<1){
		//MESSAGE_5
		MessageBox(GetText(MESSAGE_5), GetText(APPHEADER),MB_OK|MB_ICONINFORMATION);
		return;
	}

	savedCounter = 0;
	DriveHopper = false;

	m_bStop.EnableWindow(TRUE);
	m_bStart.EnableWindow(FALSE);
	EnableControls(FALSE);

	//Read in the selected streams
	ReadVTSTree();

	//Is machinist.dll available? If yes activate, else leave deactivate
	if(DVDTransfer.GetUseDeCSS() == -1)
	{
		DVDTransfer.SetAuthorizeDrive(DISABLE_AUTHORIZATION);
		DVDTransfer.SetUseDeCSS(DISABLE_DECSS);
	}else{
		DVDTransfer.SetAuthorizeDrive(ENABLE_AUTHORIZATION);
		DVDTransfer.SetUseDeCSS(ENABLE_DECSS);
	}


	//Set Extended Settings
	//First use the deposite Buffer of ~200MB. Attention: It is possibel that 
	//the Image will be to big. The Deposite Buffer is special for Parts of DVD
	//that cannot recompressed.
	if(xDeposite.GetCheck() == BST_CHECKED)
		DVDTransfer.ForceTargetSize(true);
	else
		DVDTransfer.ForceTargetSize(false);

	//Quality: 0 = Fucking fast but Blockerrors are possible
	//Quality: 1 = Good Speed and good Quality. We will beat you, DVDShrink.
	if(xSpeedB.GetCheck() == BST_CHECKED)
		DVDTransfer.SetQuality(0);
	else
		DVDTransfer.SetQuality(1);
	
	//Start the Thread
	int id;
	stopFlag = 0;
	threadHandle = _beginthreadex(NULL, 6553600, WorkingThread, this, 0, (unsigned int *) &id);

	SetTimer(100, 1000, NULL);
	onWork = true;

	::AfxGetApp()->m_pMainWnd->ShowWindow(SW_MINIMIZE);
	//SW_MINIMIZE
}

/*****************************************************************************
 * OnTimer
 * Here we will fil lall Status/Progress Information
 *****************************************************************************/
void CDoShrink::OnTimer(UINT nIDEvent)
{

	CString timeString;
	int h, m, s, tmp, fps;
	CRect rect;

	int frame = DVDTransfer.GetNumFrames();
	timeString.Format(_T("%i"),frame);

	smallWindow.infFrame.SetWindowText(timeString);
	smallWindow.infFrame.GetWindowRect(&rect);
	smallWindow.ScreenToClient(rect);
	smallWindow.InvalidateRect(&rect,1);

	savedCounter++;
	if(savedCounter != 0) fps = (float)frame / savedCounter;
	else				  fps = frame;
	timeString.Format(_T("%i"),fps);
	smallWindow.infFPS.SetWindowText(timeString);
	smallWindow.infFPS.GetWindowRect(&rect);
	smallWindow.ScreenToClient(rect);
	smallWindow.InvalidateRect(&rect,1);


	smallWindow.m_burnprogress.SetPos((DVDTransfer.GetReadKB()*100)/DVDTransfer.GetReadLimitKB());

	int dataOutput = DVDTransfer.GetWrittenKB() / 1024;
	timeString.Format(_T("%i"),dataOutput);
	smallWindow.infDataOut.SetWindowText(timeString);
	smallWindow.infDataOut.GetWindowRect(&rect);
	smallWindow.ScreenToClient(rect);
	smallWindow.InvalidateRect(&rect,1);


	// calculate elapsed time
	h = DVDTransfer.GetElapsedTimeSec() / 3600;
	m = (DVDTransfer.GetElapsedTimeSec() / 60) % 60;
	s = DVDTransfer.GetElapsedTimeSec() % 60;

	timeString.Format(_T("%02i:%02i:%02i"), h, m, s);
	smallWindow.infElapse.SetWindowText(timeString);
	
	smallWindow.infElapse.GetWindowRect(&rect);
	smallWindow.ScreenToClient(rect);
	smallWindow.InvalidateRect(&rect,1);

	if(DVDTransfer.GetEstimatedTimeSec() != -1)
	{
		tmp = DVDTransfer.GetEstimatedTimeSec();

		h = tmp / 3600;
		m = (tmp / 60) % 60;
		s = tmp % 60;

		timeString.Format(_T("%02i:%02i:%02i"), h, m, s);
		smallWindow.infEstim.SetWindowText(timeString);
		smallWindow.infEstim.GetWindowRect(&rect);
		smallWindow.ScreenToClient(rect);
		smallWindow.InvalidateRect(&rect,1);

		tmp = DVDTransfer.GetRemainingTimeSec();

		// calucalte remaining time
		h = tmp / 3600;
		m =	(tmp / 60) % 60;
		s = tmp % 60;

		timeString.Format(_T("%02i:%02i:%02i"), h, m, s);
		smallWindow.infRemain.SetWindowText(timeString);
		smallWindow.infRemain.GetWindowRect(&rect);
		smallWindow.ScreenToClient(rect);
		smallWindow.InvalidateRect(&rect,1);
	}

	UpdateWindow();

	if(threadHandle == 0) 
	{
		KillTimer(100);
		EnableControls(TRUE);
		m_bStop.EnableWindow(FALSE);
		m_bStart.EnableWindow(TRUE);
	}

	CBDialog::OnTimer(nIDEvent);
}

/*****************************************************************************
 * WorkingThread
 * In this thread the main process will work.
 *****************************************************************************/
unsigned __stdcall WorkingThread(void *pDVDDlg)
{

	CDoShrink *pDlg = (CDoShrink *) pDVDDlg;

	CString outpath;
	pDlg->cOutputFile.GetWindowText(outpath);


	pDlg->smallWindow.ShowWindow(TRUE);

	char xpath[256];
	CStringToAnsi(outpath.GetBuffer(outpath.GetLength()),xpath);
	int result = pDlg->DVDTransfer.TransferPath((char *)xpath, &pDlg->stopFlag);

	ReleaseCapture();
	pDlg->EndWaitCursor();
	//MESSAGE_6
	if(result == -6) MessageBox(NULL, GetText(MESSAGE_6), GetText(APPHEADER), MB_OK | MB_ICONEXCLAMATION);
	//MESSAGE_7
	if(result == -5) MessageBox(NULL, GetText(MESSAGE_7), GetText(APPHEADER), MB_OK | MB_ICONEXCLAMATION);
	//MESSAGE_8
	if(result == -2) MessageBox(NULL, GetText(MESSAGE_8), GetText(APPHEADER), MB_OK | MB_ICONEXCLAMATION);


	if(result == 0 && pDlg->DriveHopper == false)
		MessageBox(NULL, GetText(MESSAGE_9), GetText(APPHEADER), MB_OK | MB_ICONINFORMATION); //MESSAGE_9

	if(result > 0)
		MessageBox(NULL, GetText(MESSAGE_10), GetText(APPHEADER), MB_OK | MB_ICONINFORMATION); //MESSAGE_10

	pDlg->onWork = false;
	pDlg->threadHandle = 0;
	pDlg->EnableControls(TRUE);

	return 0;

}
void CDoShrink::OnBnClickedProsettings()
{
	if(xDown.GetCheck()==1){
		this->GetDlgItem(IDC_DEPOSITE)->ShowWindow(TRUE);
		this->GetDlgItem(IDC_SPEEDB)->ShowWindow(TRUE);
	}else{
		this->GetDlgItem(IDC_DEPOSITE)->ShowWindow(FALSE);
		this->GetDlgItem(IDC_SPEEDB)->ShowWindow(FALSE);
	}
}


/*****************************************************************************
 * EnableControls
 * Deactivate...Remember..they are really stupid
 *****************************************************************************/
void CDoShrink::EnableControls(BOOL show)
{
	m_bSource.EnableWindow(show);
	m_bTarget.EnableWindow(show);
	mSlider.EnableWindow(show);
	VTSTree.EnableWindow(show);
}

/*****************************************************************************
 * OnOpenImage
 * Analayze and read in the contents of the selected DVDMovie
 *****************************************************************************/
void CDoShrink::OnOpenImage(){
	// TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
	CString inpath;
	cInputFile.GetWindowText(inpath);

	if(inpath.GetLength()<=1){
		MessageBox(_T("Please select an Input Path before open!"),_T("FoxTranscoder Warning"),MB_OK);
		return;
	}

	//Clear The TreeView
	VTSTree.DeleteAllItems();

	//Opions, Use Auth or not
	if(DVDTransfer.GetUseDeCSS() == -1)
	{
		DVDTransfer.SetAuthorizeDrive(DISABLE_AUTHORIZATION);
		DVDTransfer.SetUseDeCSS(DISABLE_DECSS);
	}else{
		DVDTransfer.SetAuthorizeDrive(ENABLE_AUTHORIZATION);
		DVDTransfer.SetUseDeCSS(ENABLE_DECSS);
	}

	int result;
	char xpath[256];
	CStringToAnsi(inpath.GetBuffer(inpath.GetLength()),xpath);
	result = DVDTransfer.Open((char *)xpath);

	//MESSAGE_3
	if(result == -2) MessageBox(GetText(MESSAGE_3), GetText(APPHEADER), MB_OK | MB_ICONEXCLAMATION);
	// if there is a read problem or there is nothing to transfer
	//MESSAGE_4
	if(result == -4) MessageBox(GetText(MESSAGE_4), GetText(APPHEADER), MB_OK | MB_ICONEXCLAMATION);

	// if success populate tree
	if(result == 1)
	{
		movieOnly.EnableWindow(TRUE);
		wholeDVD.EnableWindow(TRUE);
		customDVD.EnableWindow(TRUE);
		movieOnly.SetCheck(FALSE);
		wholeDVD.SetCheck(FALSE);
		customDVD.SetCheck(TRUE);

		ReleaseVTSTreeView();
		VTSTree.EnableWindow(TRUE);

		stdAud.EnableWindow(FALSE);
		stdSub.EnableWindow(FALSE);
	}
}

/*****************************************************************************
 * FillMultiLangGui
 * Set the new Static Text
 *****************************************************************************/
void CDoShrink::FillMultiLangGui()
{
	this->GetDlgItem(IDC_HEADER1)->SetWindowText(GetText(HEADER_2));
	this->GetDlgItem(IDC_HEADER2)->SetWindowText(GetText(HEADER_3));
	this->GetDlgItem(IDC_HEADER3)->SetWindowText(GetText(HEADER_5));
	this->GetDlgItem(IDC_HEADER4)->SetWindowText(GetText(HEADER_1));
	this->GetDlgItem(IDC_HEADER5)->SetWindowText(GetText(HEADER_13));
	this->GetDlgItem(IDC_DEPOSITE)->SetWindowText(GetText(GUI_11));
	this->GetDlgItem(IDC_SPEEDB)->SetWindowText(GetText(GUI_12));
	this->GetDlgItem(IDC_MOVIEONLY)->SetWindowText(GetText(STATIC_7));
	this->GetDlgItem(IDC_WHOLEDVD)->SetWindowText(GetText(STATIC_8));
	this->GetDlgItem(IDC_CUSTOM)->SetWindowText(GetText(STATIC_9));

	m_ToolTip.AddTool(&m_bSource,GetText(TOOL_1));
	m_ToolTip.AddTool(&m_bTarget,GetText(TOOL_2));
	m_ToolTip.AddTool(&m_bStart,GetText(TOOL_3));
	m_ToolTip.AddTool(&m_bStop,GetText(TOOL_4));
	m_ToolTip.AddTool(&mSlider,GetText(TOOL_5));
	m_ToolTip.AddTool(&xDeposite,GetText(TOOL_9));
	m_ToolTip.AddTool(&xSpeedB,GetText(TOOL_10));

}

BOOL CDoShrink::PreTranslateMessage(MSG* pMsg)
{
	m_ToolTip.RelayEvent(pMsg);

	return CBDialog::PreTranslateMessage(pMsg);
}

UserTransferAlert::UserTransferAlert(void)
{
}

UserTransferAlert::~UserTransferAlert(void)
{
}

// derived callback routine
int UserTransferAlert::CallBack(int alert, int param, void *pTransfer)
{
	switch(alert)
	{
		case ALERT_PREVIEW_AVAIL:
			HBITMAP hprevBitmap;
			hprevBitmap = bmpStatic->SetBitmap((HBITMAP)param);
			DeleteObject(hprevBitmap);
			return 1; // we keep the current hbitmap
		default: return -1;
	}
}

void UserTransferAlert::SetBitmapStatic(CStatic *bmpStatic)
{
	this->bmpStatic = bmpStatic;
}
