/*****************************************************************************
 * SliderCtrlEx.cpp: ShrinkTo5 Skinned Slider class
 *****************************************************************************
 * Copyright (C) 2004-2005 ShrinkTo5
 *
 * Authors: Ocrana		 <info@shrinkto5.com>
 *          Andrej Grecu <info@shrinkto5.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#include "stdafx.h"
#include "SliderCtrlEx.h"
#include "..\resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CSliderCtrlEx

CSliderCtrlEx::CSliderCtrlEx()
{

}

CSliderCtrlEx::~CSliderCtrlEx()
{

}


BEGIN_MESSAGE_MAP(CSliderCtrlEx, CSliderCtrl)
	//{{AFX_MSG_MAP(CSliderCtrlEx)
	ON_NOTIFY_REFLECT(NM_CUSTOMDRAW, OnCustomDraw)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSliderCtrlEx message handlers
void CSliderCtrlEx::SetSliderGeneral(int thisType,CWnd *m_pSliderP){
	CBitmap BTmp;
	switch(thisType){
		case 1: //MPEGSLIDER2:
			imageList1.Create(216, 60, TRUE|ILC_COLOR32|ILC_MASK, 220, 0);
			ASSERT(imageList1.m_hImageList);	
			BTmp.LoadBitmap(IDB_DSLIDER);
			imageList1.Add(&BTmp, RGB(0,0,0));
			BTmp.Detach();
			break;		
	}
	sliderType = thisType;
	isSet = TRUE;
	m_pSliderPos2=m_pSliderP;
	RedrawWindow();
}

void CSliderCtrlEx::OnCustomDraw(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int loopMax = 1;
	LPNMCUSTOMDRAW lpCustDraw = (LPNMCUSTOMDRAW)pNMHDR;

	////////////////////////////////////////////////////////////////////////////////
	// OnCustomDraw() is called at many different stages during the painting process
	// of the control. We only care about the PREPAINT state or the ITEMPREPAINT
	// state and not always then.
	//
	// If we want to be notified about subcontrol painting, we have to say so when
	// we get the initial PREPAINT message.
	////////////////////////////////////////////////////////////////////////////////
	if(lpCustDraw->dwDrawStage == CDDS_PREPAINT)
	{
		// should we report slider's position?
		int curVal = GetPos();
		/*
		if((m_Callback != NULL)	&& (curVal != m_oldPosition))
		{
			m_oldPosition = curVal;
			m_Callback(m_p2Object, m_data1, curVal, m_IsDragging);
		}*/

		// If we don't have any special coloring to do, skip all the silliness...
		if(loopMax <= 0)
		{
			*pResult = CDRF_DODEFAULT;
		}
		else
		{
			// We want to be informed when each part of the control is being
			// processed so we can intercept the channel drawing.
			*pResult = CDRF_NOTIFYITEMDRAW;	// send messages for each piece-part
		}
		return;
	}


	if((lpCustDraw->dwDrawStage == CDDS_ITEMPREPAINT) && (lpCustDraw->dwItemSpec != TBCD_THUMB))
	{
		*pResult = CDRF_DODEFAULT;
		return;
	}

	if(isSet==FALSE)
		return;


	// Get the coordinates of the control's window
	CRect crect;
	GetClientRect(crect);	// client coordinates (top = left = 0, bottom = height, right = width)

	CDC *pDC = CDC::FromHandle(lpCustDraw->hdc);
	CDC SaveCDC;
	SaveCDC.CreateCompatibleDC(pDC);

	switch(sliderType){
		case 1:
			imageList1.DrawIndirect(pDC,0,CPoint(0,0),CSize(216, 60),CPoint(0, 0));
			break;
	}

	pDC->BitBlt(0,0,crect.Width(),crect.Height(),&SaveCDC,0,0,SRCCOPY);

	DeleteDC(SaveCDC);

	*pResult = CDRF_DODEFAULT;
	if(m_pSliderPos2)
		m_pSliderPos2->Invalidate();
}



