/*****************************************************************************
 * ShrinkTo5GuiDlg.h: ShrinkTo5 GUI class
 *****************************************************************************
 * Copyright (C) 2004-2005 ShrinkTo5
 *
 * Authors: Ocrana		 <info@shrinkto5.com>
 *          Andrej Grecu <info@shrinkto5.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#pragma once
#include "./GUI/BDialog.h"
#include "./GUI/SliderCtrlEx.h"
#include "./GUI/xSkinButton.h"
#include "./GUI/MltiTree.h"
#include "./GUI/TransparentButton.h"


#include "BurnPlugin.h"
#include "DoShrink.h"

#include "afxcmn.h"
#include "afxwin.h"


// CShrinkTo5GuiDlg Dialogfeld
class CShrinkTo5GuiDlg : public CBDialog
{
// Konstruktion
public:
	CShrinkTo5GuiDlg(CWnd* pParent = NULL);	// Standardkonstruktor

// Dialogfelddaten
	enum { IDD = IDD_SHRINKTO5GUI_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	

// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Funktionen fr die Meldungstabellen
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();

	DECLARE_MESSAGE_MAP()

public:


	//Functions
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnBnClickedMlang();
	void FillMultiLangGui();
	//Default MFC Widgets
	CToolTipCtrl m_ToolTip;
	//Custom Widgets
	CxSkinButton m_bLang;
	afx_msg void OnBnClickedBurn();


protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
public:
	afx_msg void OnBnClickedErase();

	CDoShrink	drawArea1;
	CBurnPlugin	drawArea2;
	afx_msg void OnBnClickedSetburn();
	afx_msg void OnBnClickedSetshrink();

	CxSkinButton xShrink;
	CxSkinButton xBurn;
	afx_msg void OnBnClickedCbshrink();
	afx_msg void OnBnClickedCbburn();
};
