/*****************************************************************************
 * UnicodeHelpers.cpp: Class to make working with Unicode easier
 *****************************************************************************
 * Copyright (C) 2004-2005 ShrinkTo5
 *
 * Authors: Ocrana		 <info@shrinkto5.com>
 *          Andrej Grecu <info@shrinkto5.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/
//// Windows-Version
#if _MSC_VER >= 1300

// = 0x400		-> Damit wir kompatibel sind.
#	undef WINVER
#	define WINVER			0x0400

// >= 0x0502	-> Windows Server 2003 family
// >= 0x0501	-> Windows XP
// >= 0x0500	-> Windows 2000
// >= 0x0400	-> Windows NT 4.0
#	undef _WIN32_WINNT
#	define _WIN32_WINNT		0x0500

// = 0x0500		-> Windows NT based
// = 0x0490		-> Windows Me
// >= 0x0410 	-> Windows 98
#	undef _WIN32_WINDOWS
#	define _WIN32_WINDOWS	0x0500
#endif
//// Ende (Windows-Version)

#include <afxwin.h>				// MFC-Kern- und -Standardkomponenten


char WideCharToSingleChar(TCHAR WideChar)
{
	union
	{
		TCHAR w;
		BYTE s[sizeof(TCHAR)];
	} wide;
	wide.w=WideChar;
	return ((wide.s[0]<0)?'_':wide.s[0]);
}

void CStringToAnsi(CString str, char* ANSI)
{
	for(int i=0;i<str.GetLength();++i,++ANSI)
	{
		*ANSI=WideCharToSingleChar(str[i]);
	}
	*ANSI=0;
}

#ifdef UNICODE
CString AnsiToCString(const char* ANSI, int nLength)
{
	CString strResult;
	for(int i=0;i<nLength;++i,++ANSI)
		strResult+=wchar_t((BYTE)(*ANSI));
	return strResult;
}
CString CStringToAnsiCString(CString str)
{
	char *pcTmp = new char[str.GetLength()+1];
	CStringToAnsi(str,pcTmp);
	CString strReturn=AnsiToCString(pcTmp,str.GetLength());
	delete[] pcTmp;
    return strReturn;
}
#else
CString AnsiToCString(const char* ANSI, int nLength)
{
	return CString(ANSI);
}
CString CStringToAnsiCString(CString str)
{
	return str;
}
#endif