/*****************************************************************************
 * WorkWindow.h: Worker Dialog class
 *****************************************************************************
 * Copyright (C) 2004-2005 ShrinkTo5
 *
 * Authors: Ocrana		 <info@shrinkto5.com>
 *          Andrej Grecu <info@shrinkto5.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "./GUI/BDialog.h"
#include "resource.h"

// CWorkWindow-Dialogfeld

class CWorkWindow : public CBDialog
{
	DECLARE_DYNAMIC(CWorkWindow)

public:
	CWorkWindow(CWnd* pParent = NULL);   // Standardkonstruktor
	virtual ~CWorkWindow();

// Dialogfelddaten
	enum { IDD = IDD_WORKWINDOW };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

	DECLARE_MESSAGE_MAP()
public:
	CStatic infFrame;
	CStatic infFPS;
	CStatic infDataOut;
	CStatic infElapse;
	CStatic infEstim;
	CStatic infRemain;
	CProgressCtrl m_burnprogress;
	CStatic cPreview;
	CFont new_font;
	virtual BOOL OnInitDialog();

    unsigned int m_nWndLeft;   // Message window left corner screen coordinates   
    unsigned int m_nWndTop;    // Message window top corner screen coordinates
    unsigned int m_nWndRight;  // Message window right corner screen coordinates
    unsigned int m_nWndBottom; // Message window bottom corner screen coordinates
    unsigned int m_nWndWidth;            // Message window width
	unsigned int m_nWndHeight;           // Mesaage window height
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnBnClickedCancel();
	CWnd *opener;
	void FillMultiLangGui();
	
};
